import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:flutter_pull_refresh_sdk/flutter_pull_refresh_sdk.dart';
import 'package:flutter_pull_refresh_sdk_example/pullRefreshTest.dart';

void main() => runApp(MyApp());

class ItemModel{
  ItemModel({this.title});
  String title;
}
class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> with SingleTickerProviderStateMixin{
  RefreshController refreshController = RefreshController(initialRefresh: true);
  List <ItemModel>dataArr = [
    ItemModel(title: '1'),
    ItemModel(title: '2'),
    ItemModel(title: '3'),
    ItemModel(title: '4'),
    ItemModel(title: '5'),
    ItemModel(title: '6'),
    ItemModel(title: '7'),
    ItemModel(title: '8'),
    ItemModel(title: '9'),
    ItemModel(title: '10'),
    ItemModel(title: '11'),
    ItemModel(title: '12'),
    ItemModel(title: '13'),
    ItemModel(title: '14'),
    ItemModel(title: '15'),
    ItemModel(title: '16'),
    ItemModel(title: '17'),
  ];
  List handingOrderList = [];
  int pageSize = 8;
  int currentPage = 1;
  int loadingStatus = 0;

  @override
  void initState() {
    super.initState();
  }
  
  @override
  void dispose() {
    refreshController.dispose();
    super.dispose();
  }
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: SafeArea(
          child: pullRefreshItem(),
        )
      ),
    );
  }
  Widget pullRefreshItem(){
    return PullRefreshTest(
      refreshController: refreshController,
      onRefreshListener: requestOrderListData,
      onLoadMoreListener: requestMoreOrderStateList,
      child: contrainView(),
      loadStatus: loadingStatus,
    );
  }
  Widget contrainView() {
    return ListView.builder(
        itemBuilder: (context, i) {
          return contraintItem(context, handingOrderList[i]);
        },
        itemCount: handingOrderList.length,
    );
  }
  Widget contraintItem(BuildContext context,ItemModel item){
    return InkWell(
      onTap: (){
        print('-----------------${item.title}++++++++++++++++++');
      },
      child: Container(
        margin: EdgeInsets.all(10),
        height: 80,
        child: Text(
          item.title ?? '',
          style: TextStyle(
            fontWeight: FontWeight.bold,
            fontSize: 14,
            color: Colors.black
          ),
        ),
      ),
    );
  }
  ///==================================Load==============================
  requestOrderListData(){
    currentPage = 1;
    refreshController.loadComplete();
    List arr = dataArr.sublist(0,pageSize);
    if(arr.length > 0){
      // setState(() {
      //   if(currentPage == 1){
      //     handingOrderList = [];
      //   }
      //   loadingStatus = 1;
      //   handingOrderList.addAll(arr);
      // });
      setState(() {
        loadingStatus = -1;
      });
      Future.delayed(Duration(seconds:3),(){
        refreshController.refreshCompleted();
      });
    }else{
      setState(() {
        loadingStatus = -1;
      });
      refreshController.loadFailed();
    }
  }
  requestMoreOrderStateList(){
    currentPage++;
    refreshController.loadComplete();
    List arr = [];
    if(dataArr.sublist(pageSize*(currentPage-1),dataArr.length).length > pageSize){
       arr = dataArr.sublist(pageSize*(currentPage-1),pageSize*currentPage);
    }else{
      arr = dataArr.sublist(pageSize*(currentPage-1),dataArr.length);
    }
    
    setState(() {
        handingOrderList.addAll(arr);
    });
    if(arr.length < pageSize){
      refreshController.loadNoData();
      refreshController.refreshCompleted();
    }else{
      refreshController.refreshCompleted();
    }
  }
}
